"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var ChainGunLink_1 = require("./ChainGunLink");
var GunEvent_1 = require("./GunEvent");
var diffGunCRDT_1 = require("./diffGunCRDT");
var mergeGunNodes_1 = require("./mergeGunNodes");
var diffSets_1 = require("./diffSets");
var ChainGun = /** @class */ (function () {
    function ChainGun(LinkClass) {
        if (LinkClass === void 0) { LinkClass = ChainGunLink_1.ChainGunLink; }
        this._opt = {};
        this._graph = {};
        this._listeners = {};
        this._readMiddleware = [];
        this._writeMiddleware = [];
        this.LinkClass = LinkClass;
    }
    ChainGun.prototype.opt = function (options) {
        this._opt = __assign(__assign({}, this._opt), options);
        return this;
    };
    /**
     * Register graph middleware
     *
     * @param middleware The middleware function to add
     * @param kind Optionaly register write middleware instead of read by passing "write"
     */
    ChainGun.prototype.use = function (middleware, kind) {
        if (kind === void 0) { kind = "read"; }
        if (kind === "read") {
            this._readMiddleware.push(middleware);
        }
        else if (kind === "write") {
            this._writeMiddleware.push(middleware);
        }
        return this;
    };
    /**
     * Traverse a location in the graph
     *
     * @param key Key to read data from
     * @param cb
     * @returns New chain context corresponding to given key
     */
    ChainGun.prototype.get = function (soul, cb) {
        return new this.LinkClass(this, soul);
    };
    /**
     * Write node data
     *
     * @param data one or more gun nodes keyed by soul
     */
    ChainGun.prototype.put = function (data) {
        throw new Error("put() isn't supported yet");
        return this;
    };
    /**
     * Update node data in this chain from some local or external source
     *
     * @param soul soul of node to update
     * @param data node data to include
     */
    ChainGun.prototype.addNodeData = function (data) {
        return __awaiter(this, void 0, void 0, function () {
            var diff, i, souls, i, soul, listener, node;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        diff = data ? diffGunCRDT_1.diffGunCRDT(this._graph, data) : undefined;
                        i = 0;
                        _a.label = 1;
                    case 1:
                        if (!(i < this._readMiddleware.length)) return [3 /*break*/, 4];
                        if (!diff)
                            return [2 /*return*/];
                        return [4 /*yield*/, this._readMiddleware[i](diff, this._graph)];
                    case 2:
                        diff = _a.sent();
                        _a.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4:
                        if (!diff)
                            return [2 /*return*/];
                        souls = Object.keys(diff);
                        for (i = 0; i < souls.length; i++) {
                            soul = souls[i];
                            listener = this._listeners[soul];
                            if (!listener) {
                                this._forget(soul);
                                continue;
                            }
                            node = (this._graph[soul] = mergeGunNodes_1.mergeGunNodes(this._graph[soul], diff[soul]));
                            listener.trigger(node, soul);
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    ChainGun.prototype.query = function (path, cb) {
        var _this = this;
        var lastSouls = [];
        var currentValue;
        var updateQuery = function () {
            var _a = _this._getPathData(path), souls = _a.souls, value = _a.value, complete = _a.complete;
            var _b = diffSets_1.diffSets(lastSouls, souls), added = _b[0], removed = _b[1];
            if ((complete && typeof currentValue === "undefined") ||
                (typeof value !== "undefined" && value !== currentValue)) {
                currentValue = value;
                cb(value, path[path.length - 1]);
            }
            added.forEach(function (soul) { return _this._request(soul, updateQuery); });
            removed.forEach(function (soul) { return _this._unlisten(soul, updateQuery); });
        };
        updateQuery();
        return function () {
            lastSouls.forEach(function (soul) { return _this._unlisten(soul, updateQuery); });
        };
    };
    ChainGun.prototype._request = function (soul, cb) {
        if (!this._opt.askNodes)
            return;
        this._listen(soul, cb);
        this._opt.askNodes([soul]);
    };
    ChainGun.prototype._listen = function (soul, cb) {
        var _this = this;
        var listener = this._listeners[soul];
        if (!listener) {
            listener = this._listeners[soul] = new GunEvent_1.GunEvent(soul);
        }
        listener.on(cb);
        return function () { return _this._unlisten(soul, cb); };
    };
    ChainGun.prototype._unlisten = function (soul, cb) {
        var listener = this._listeners[soul];
        if (listener)
            listener.off(cb);
        if (listener.listenerCount() <= 0)
            this._forget(soul);
    };
    ChainGun.prototype._getPathData = function (keys) {
        var lastKey = keys[keys.length - 1];
        if (keys.length === 1) {
            return {
                souls: keys,
                value: this._graph[lastKey],
                complete: lastKey in this._graph
            };
        }
        var _a = this._getPathData(keys.slice(0, keys.length - 1)), parentValue = _a.value, souls = _a.souls;
        if (typeof parentValue !== "object") {
            return {
                souls: souls,
                value: undefined,
                complete: typeof parentValue !== "undefined"
            };
        }
        var value = parentValue[lastKey];
        if (!value) {
            return {
                souls: souls,
                value: value,
                complete: true
            };
        }
        var edgeSoul = value["#"];
        if (edgeSoul) {
            return {
                souls: __spreadArrays(souls, [edgeSoul]),
                value: this._graph[edgeSoul],
                complete: edgeSoul in this._graph
            };
        }
        return {
            souls: souls,
            value: value,
            complete: true
        };
    };
    ChainGun.prototype._forget = function (soul) {
        if (this._listeners[soul]) {
            this._listeners[soul].reset();
            delete this._listeners[soul];
        }
        delete this._graph[soul];
        return this;
    };
    return ChainGun;
}());
exports.ChainGun = ChainGun;
//# sourceMappingURL=ChainGun.js.map