"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var generateMessageId_1 = require("./generateMessageId");
function attachToGun(gunDb, chain) {
    var requests = {};
    var requestsBySoul = {};
    function askNodes(souls) {
        for (var i = 0; i < souls.length; i++) {
            var soul = souls[i];
            if (soul in requestsBySoul)
                continue;
            var msgId = generateMessageId_1.generateMessageId();
            requests[msgId] = soul;
            requestsBySoul[soul] = msgId;
            gunDb.on("in", {
                "#": msgId,
                get: {
                    "#": soul
                }
            });
        }
    }
    gunDb.on("put", function (request) {
        var _a;
        this.to.next(request);
        if (!request)
            return;
        var respondingTo = request["@"];
        var requestedSoul = respondingTo && requests[respondingTo];
        if (request.put) {
            chain.addNodeData(request.put);
        }
        else if (requestedSoul) {
            chain.addNodeData((_a = {},
                _a[requestedSoul] = undefined,
                _a));
        }
    });
    chain.opt({ askNodes: askNodes });
    gunDb.chaingun = chain;
    return gunDb;
}
exports.attachToGun = attachToGun;
//# sourceMappingURL=attachToGun.js.map