"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var DEFAULT_OPTS = {
    futureGrace: 10 * 60 * 1000,
    Lexical: JSON.stringify // what gun.js uses
};
var EMPTY = {};
function diffGunCRDT(existingGraph, updatedGraph, opts) {
    if (opts === void 0) { opts = DEFAULT_OPTS; }
    var _a = opts || EMPTY, _b = _a.machineState, machineState = _b === void 0 ? new Date().getTime() : _b, _c = _a.futureGrace, futureGrace = _c === void 0 ? DEFAULT_OPTS.futureGrace : _c, _d = _a.Lexical, Lexical = _d === void 0 ? DEFAULT_OPTS.Lexical : _d;
    var maxState = machineState + futureGrace; // eslint-disable-line
    var allUpdates = {};
    for (var soul in updatedGraph) {
        var existing = existingGraph[soul];
        var updated = updatedGraph[soul];
        var existingState = (existing && existing._ && existing._['>']) || EMPTY;
        var updatedState = (updated && updated._ && updated._['>']) || EMPTY;
        if (!updated) {
            if (!(soul in existingGraph))
                allUpdates[soul] = updated;
            continue;
        }
        var hasUpdates = false;
        var updates = {
            _: {
                '#': updated._['#'],
                '>': {}
            }
        };
        for (var key in updatedState) {
            var existingKeyState = existingState[key];
            var updatedKeyState = updatedState[key];
            if (updatedKeyState > maxState || !updatedKeyState)
                continue;
            if (existingKeyState && existingKeyState >= updatedKeyState)
                continue;
            if (existingKeyState === updatedKeyState) {
                var existingVal = (existing && existing[key]) || undefined;
                var updatedVal = updated[key];
                // This is based on Gun's logic
                if (Lexical(updatedVal) <= Lexical(existingVal))
                    continue;
            }
            updates[key] = updated[key];
            updates._['>'][key] = updatedKeyState;
            hasUpdates = true;
        }
        if (hasUpdates) {
            allUpdates[soul] = updates;
        }
    }
    return Object.keys(allUpdates) ? allUpdates : undefined;
}
exports.diffGunCRDT = diffGunCRDT;
//# sourceMappingURL=diffGunCRDT.js.map